#ifndef __BITSTREAM_H__
#define __BITSTREAM_H__

typedef struct {
	unsigned char	*data;				// buffer to read from
	unsigned int	size;
	unsigned int	modulus;
	unsigned int	bit_position;		// bit position in element
} CT_Bitstream;



CT_Bitstream *bitstream_create(unsigned char *data, int size);

void bitstream_delete(CT_Bitstream *stream);

void bitstream_init(CT_Bitstream *stream, unsigned char *data, int size);

int bitstream_read(CT_Bitstream *stream, int bits);

int bitstream_read_mod(CT_Bitstream *stream, int bits);

// inline

int bitstream_read_16_mod(CT_Bitstream *stream, int bits);

int bitstream_read_16(CT_Bitstream *stream, int bits);

int bitstream_read_1(CT_Bitstream *stream);

int bitstream_read_1_mod(CT_Bitstream *stream);

int bitstream_eos(CT_Bitstream *stream);

int bitstream_pos(CT_Bitstream *stream);

void bitstream_set_pos(CT_Bitstream *stream, int position);

#endif
