#ifndef __FIXPOINT_H__
#define __FIXPOINT_H__

#if DATA_WIDTH == 32
typedef signed int fixed_point;
#else
typedef signed short int fixed_point;
#endif

#define INTEGER_BITS	1 

#define fix(x)			((fixed_point)(x##L))

#define fix_add(x, y)	((x) + (y))
#define fix_sub(x, y)	((x) - (y))

#define new_fixed_to_double(x) ( ((double)x) / 1073741824 ) // x/(2^30)

/* convertion routines only used under windows */
/* ------------------------------------------- */
fixed_point  double_to_fixed(double x);
double       fixed_to_double(fixed_point x);
#ifdef _WIN32
signed short fixed_to_pcm_sample(fixed_point x);
#endif
/* ------------------------------------------- */

#endif

#if NEW_MULT == 0
	#if DATA_WIDTH == 32
		#define fix_mul(x, y)	((fixed_point)((((long long)(x))*(y)) >> (32 - INTEGER_BITS - 1) ))
	#else
		#define fix_mul(x, y)	((fixed_point)((((int)(x))*(y)) >> (16 - INTEGER_BITS - 1) ))
	#endif
# else
	#if DATA_WIDTH == 32
		fixed_point fix_mul(int, int);
	#else
		fixed_point fix_mul(fixed_point, fixed_point);
	#endif
#endif
